{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickDC;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_DC_FUNCTION_SET_VELOCITY = 1;
  BRICK_DC_FUNCTION_GET_VELOCITY = 2;
  BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY = 3;
  BRICK_DC_FUNCTION_SET_ACCELERATION = 4;
  BRICK_DC_FUNCTION_GET_ACCELERATION = 5;
  BRICK_DC_FUNCTION_SET_PWM_FREQUENCY = 6;
  BRICK_DC_FUNCTION_GET_PWM_FREQUENCY = 7;
  BRICK_DC_FUNCTION_FULL_BRAKE = 8;
  BRICK_DC_FUNCTION_GET_STACK_INPUT_VOLTAGE = 9;
  BRICK_DC_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 10;
  BRICK_DC_FUNCTION_GET_CURRENT_CONSUMPTION = 11;
  BRICK_DC_FUNCTION_ENABLE = 12;
  BRICK_DC_FUNCTION_DISABLE = 13;
  BRICK_DC_FUNCTION_IS_ENABLED = 14;
  BRICK_DC_FUNCTION_SET_MINIMUM_VOLTAGE = 15;
  BRICK_DC_FUNCTION_GET_MINIMUM_VOLTAGE = 16;
  BRICK_DC_FUNCTION_SET_DRIVE_MODE = 17;
  BRICK_DC_FUNCTION_GET_DRIVE_MODE = 18;
  BRICK_DC_FUNCTION_SET_CURRENT_VELOCITY_PERIOD = 19;
  BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY_PERIOD = 20;
  BRICK_DC_FUNCTION_RESET = 243;
  BRICK_DC_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICK_DC_CALLBACK_UNDER_VOLTAGE = 21;
  BRICK_DC_CALLBACK_EMERGENCY_SHUTDOWN = 22;
  BRICK_DC_CALLBACK_VELOCITY_REACHED = 23;
  BRICK_DC_CALLBACK_CURRENT_VELOCITY = 24;

type
  TBrickDCNotifyUnderVoltage = procedure(const voltage: word) of object;
  TBrickDCNotifyEmergencyShutdown = procedure of object;
  TBrickDCNotifyVelocityReached = procedure(const velocity: smallint) of object;
  TBrickDCNotifyCurrentVelocity = procedure(const velocity: smallint) of object;

  TBrickDC = class(TDevice)
  private
    underVoltageCallback: TBrickDCNotifyUnderVoltage;
    emergencyShutdownCallback: TBrickDCNotifyEmergencyShutdown;
    velocityReachedCallback: TBrickDCNotifyVelocityReached;
    currentVelocityCallback: TBrickDCNotifyCurrentVelocity;
  protected
    procedure CallbackWrapperUnderVoltage(const packet: TByteArray); virtual;
    procedure CallbackWrapperEmergencyShutdown(const packet: TByteArray); virtual;
    procedure CallbackWrapperVelocityReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperCurrentVelocity(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure SetVelocity(const velocity: smallint); virtual;
    function GetVelocity: smallint; virtual;
    function GetCurrentVelocity: smallint; virtual;
    procedure SetAcceleration(const acceleration: word); virtual;
    function GetAcceleration: word; virtual;
    procedure SetPWMFrequency(const frequency: word); virtual;
    function GetPWMFrequency: word; virtual;
    procedure FullBrake; virtual;
    function GetStackInputVoltage: word; virtual;
    function GetExternalInputVoltage: word; virtual;
    function GetCurrentConsumption: word; virtual;
    procedure Enable; virtual;
    procedure Disable; virtual;
    function IsEnabled: boolean; virtual;
    procedure SetMinimumVoltage(const voltage: word); virtual;
    function GetMinimumVoltage: word; virtual;
    procedure SetDriveMode(const mode: byte); virtual;
    function GetDriveMode: byte; virtual;
    procedure SetCurrentVelocityPeriod(const period: word); virtual;
    function GetCurrentVelocityPeriod: word; virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
    property OnUnderVoltage: TBrickDCNotifyUnderVoltage read underVoltageCallback write underVoltageCallback;
    property OnEmergencyShutdown: TBrickDCNotifyEmergencyShutdown read emergencyShutdownCallback write emergencyShutdownCallback;
    property OnVelocityReached: TBrickDCNotifyVelocityReached read velocityReachedCallback write velocityReachedCallback;
    property OnCurrentVelocity: TBrickDCNotifyCurrentVelocity read currentVelocityCallback write currentVelocityCallback;
  end;

implementation

constructor TBrickDC.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'DC Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICK_DC_CALLBACK_UNDER_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperUnderVoltage;
  callbackWrappers[BRICK_DC_CALLBACK_EMERGENCY_SHUTDOWN] := {$ifdef FPC}@{$endif}CallbackWrapperEmergencyShutdown;
  callbackWrappers[BRICK_DC_CALLBACK_VELOCITY_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVelocityReached;
  callbackWrappers[BRICK_DC_CALLBACK_CURRENT_VELOCITY] := {$ifdef FPC}@{$endif}CallbackWrapperCurrentVelocity;
end;

procedure TBrickDC.SetVelocity(const velocity: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_VELOCITY, 6);
  LEConvertInt16To(velocity, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetVelocity: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_VELOCITY, response);
  result := LEConvertInt16From(4, response);
end;

function TBrickDC.GetCurrentVelocity: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickDC.SetAcceleration(const acceleration: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_ACCELERATION, 6);
  LEConvertUInt16To(acceleration, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetAcceleration: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_ACCELERATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_ACCELERATION, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickDC.SetPWMFrequency(const frequency: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_PWM_FREQUENCY, 6);
  LEConvertUInt16To(frequency, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetPWMFrequency: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_PWM_FREQUENCY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_PWM_FREQUENCY, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickDC.FullBrake;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_FULL_BRAKE, 4);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetStackInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_STACK_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_STACK_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickDC.GetExternalInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickDC.GetCurrentConsumption: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_CURRENT_CONSUMPTION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_CURRENT_CONSUMPTION, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickDC.Enable;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_ENABLE, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickDC.Disable;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_DISABLE, 4);
  SendRequestNoResponse(request);
end;

function TBrickDC.IsEnabled: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_IS_ENABLED, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_IS_ENABLED, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickDC.SetMinimumVoltage(const voltage: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_MINIMUM_VOLTAGE, 6);
  LEConvertUInt16To(voltage, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetMinimumVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_MINIMUM_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_MINIMUM_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickDC.SetDriveMode(const mode: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_DRIVE_MODE, 5);
  LEConvertUInt8To(mode, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetDriveMode: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_DRIVE_MODE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_DRIVE_MODE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickDC.SetCurrentVelocityPeriod(const period: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_SET_CURRENT_VELOCITY_PERIOD, 6);
  LEConvertUInt16To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetCurrentVelocityPeriod: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_CURRENT_VELOCITY_PERIOD, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickDC.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickDC.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_DC_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_DC_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickDC.CallbackWrapperUnderVoltage(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(underVoltageCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    underVoltageCallback(voltage);
  end;
end;

procedure TBrickDC.CallbackWrapperEmergencyShutdown(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(emergencyShutdownCallback)) then begin
    emergencyShutdownCallback();
  end;
end;

procedure TBrickDC.CallbackWrapperVelocityReached(const packet: TByteArray);
var velocity: smallint;
begin
  if (Assigned(velocityReachedCallback)) then begin
    velocity := LEConvertInt16From(4, packet);
    velocityReachedCallback(velocity);
  end;
end;

procedure TBrickDC.CallbackWrapperCurrentVelocity(const packet: TByteArray);
var velocity: smallint;
begin
  if (Assigned(currentVelocityCallback)) then begin
    velocity := LEConvertInt16From(4, packet);
    currentVelocityCallback(velocity);
  end;
end;

end.
