{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickIMU;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_IMU_FUNCTION_GET_ACCELERATION = 1;
  BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD = 2;
  BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY = 3;
  BRICK_IMU_FUNCTION_GET_ALL_DATA = 4;
  BRICK_IMU_FUNCTION_GET_ORIENTATION = 5;
  BRICK_IMU_FUNCTION_GET_QUATERNION = 6;
  BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE = 7;
  BRICK_IMU_FUNCTION_LEDS_ON = 8;
  BRICK_IMU_FUNCTION_LEDS_OFF = 9;
  BRICK_IMU_FUNCTION_ARE_LEDS_ON = 10;
  BRICK_IMU_FUNCTION_SET_ACCELERATION_RANGE = 11;
  BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE = 12;
  BRICK_IMU_FUNCTION_SET_MAGNETOMETER_RANGE = 13;
  BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE = 14;
  BRICK_IMU_FUNCTION_SET_CONVERGENCE_SPEED = 15;
  BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED = 16;
  BRICK_IMU_FUNCTION_SET_CALIBRATION = 17;
  BRICK_IMU_FUNCTION_GET_CALIBRATION = 18;
  BRICK_IMU_FUNCTION_SET_ACCELERATION_PERIOD = 19;
  BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD = 20;
  BRICK_IMU_FUNCTION_SET_MAGNETIC_FIELD_PERIOD = 21;
  BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD = 22;
  BRICK_IMU_FUNCTION_SET_ANGULAR_VELOCITY_PERIOD = 23;
  BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD = 24;
  BRICK_IMU_FUNCTION_SET_ALL_DATA_PERIOD = 25;
  BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD = 26;
  BRICK_IMU_FUNCTION_SET_ORIENTATION_PERIOD = 27;
  BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD = 28;
  BRICK_IMU_FUNCTION_SET_QUATERNION_PERIOD = 29;
  BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD = 30;
  BRICK_IMU_FUNCTION_RESET = 243;
  BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICK_IMU_CALLBACK_ACCELERATION = 31;
  BRICK_IMU_CALLBACK_MAGNETIC_FIELD = 32;
  BRICK_IMU_CALLBACK_ANGULAR_VELOCITY = 33;
  BRICK_IMU_CALLBACK_ALL_DATA = 34;
  BRICK_IMU_CALLBACK_ORIENTATION = 35;
  BRICK_IMU_CALLBACK_QUATERNION = 36;

type
  TArray0To9OfInt16 = array [0..9] of smallint;

  TBrickIMUNotifyAcceleration = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyMagneticField = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyAngularVelocity = procedure(const x: smallint; const y: smallint; const z: smallint) of object;
  TBrickIMUNotifyAllData = procedure(const accX: smallint; const accY: smallint; const accZ: smallint; const magX: smallint; const magY: smallint; const magZ: smallint; const angX: smallint; const angY: smallint; const angZ: smallint; const temperature: smallint) of object;
  TBrickIMUNotifyOrientation = procedure(const roll: smallint; const pitch: smallint; const yaw: smallint) of object;
  TBrickIMUNotifyQuaternion = procedure(const x: single; const y: single; const z: single; const w: single) of object;

  TBrickIMU = class(TDevice)
  private
    accelerationCallback: TBrickIMUNotifyAcceleration;
    magneticFieldCallback: TBrickIMUNotifyMagneticField;
    angularVelocityCallback: TBrickIMUNotifyAngularVelocity;
    allDataCallback: TBrickIMUNotifyAllData;
    orientationCallback: TBrickIMUNotifyOrientation;
    quaternionCallback: TBrickIMUNotifyQuaternion;
  protected
    procedure CallbackWrapperAcceleration(const packet: TByteArray); virtual;
    procedure CallbackWrapperMagneticField(const packet: TByteArray); virtual;
    procedure CallbackWrapperAngularVelocity(const packet: TByteArray); virtual;
    procedure CallbackWrapperAllData(const packet: TByteArray); virtual;
    procedure CallbackWrapperOrientation(const packet: TByteArray); virtual;
    procedure CallbackWrapperQuaternion(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure GetAcceleration(out x: smallint; out y: smallint; out z: smallint); virtual;
    procedure GetMagneticField(out x: smallint; out y: smallint; out z: smallint); virtual;
    procedure GetAngularVelocity(out x: smallint; out y: smallint; out z: smallint); virtual;
    procedure GetAllData(out accX: smallint; out accY: smallint; out accZ: smallint; out magX: smallint; out magY: smallint; out magZ: smallint; out angX: smallint; out angY: smallint; out angZ: smallint; out temperature: smallint); virtual;
    procedure GetOrientation(out roll: smallint; out pitch: smallint; out yaw: smallint); virtual;
    procedure GetQuaternion(out x: single; out y: single; out z: single; out w: single); virtual;
    function GetIMUTemperature: smallint; virtual;
    procedure LedsOn; virtual;
    procedure LedsOff; virtual;
    function AreLedsOn: boolean; virtual;
    procedure SetAccelerationRange(const range: byte); virtual;
    function GetAccelerationRange: byte; virtual;
    procedure SetMagnetometerRange(const range: byte); virtual;
    function GetMagnetometerRange: byte; virtual;
    procedure SetConvergenceSpeed(const speed: word); virtual;
    function GetConvergenceSpeed: word; virtual;
    procedure SetCalibration(const typ: byte; const data: TArray0To9OfInt16); virtual;
    function GetCalibration(const typ: byte): TArray0To9OfInt16; virtual;
    procedure SetAccelerationPeriod(const period: longword); virtual;
    function GetAccelerationPeriod: longword; virtual;
    procedure SetMagneticFieldPeriod(const period: longword); virtual;
    function GetMagneticFieldPeriod: longword; virtual;
    procedure SetAngularVelocityPeriod(const period: longword); virtual;
    function GetAngularVelocityPeriod: longword; virtual;
    procedure SetAllDataPeriod(const period: longword); virtual;
    function GetAllDataPeriod: longword; virtual;
    procedure SetOrientationPeriod(const period: longword); virtual;
    function GetOrientationPeriod: longword; virtual;
    procedure SetQuaternionPeriod(const period: longword); virtual;
    function GetQuaternionPeriod: longword; virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
    property OnAcceleration: TBrickIMUNotifyAcceleration read accelerationCallback write accelerationCallback;
    property OnMagneticField: TBrickIMUNotifyMagneticField read magneticFieldCallback write magneticFieldCallback;
    property OnAngularVelocity: TBrickIMUNotifyAngularVelocity read angularVelocityCallback write angularVelocityCallback;
    property OnAllData: TBrickIMUNotifyAllData read allDataCallback write allDataCallback;
    property OnOrientation: TBrickIMUNotifyOrientation read orientationCallback write orientationCallback;
    property OnQuaternion: TBrickIMUNotifyQuaternion read quaternionCallback write quaternionCallback;
  end;

implementation

constructor TBrickIMU.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'IMU Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICK_IMU_CALLBACK_ACCELERATION] := {$ifdef FPC}@{$endif}CallbackWrapperAcceleration;
  callbackWrappers[BRICK_IMU_CALLBACK_MAGNETIC_FIELD] := {$ifdef FPC}@{$endif}CallbackWrapperMagneticField;
  callbackWrappers[BRICK_IMU_CALLBACK_ANGULAR_VELOCITY] := {$ifdef FPC}@{$endif}CallbackWrapperAngularVelocity;
  callbackWrappers[BRICK_IMU_CALLBACK_ALL_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperAllData;
  callbackWrappers[BRICK_IMU_CALLBACK_ORIENTATION] := {$ifdef FPC}@{$endif}CallbackWrapperOrientation;
  callbackWrappers[BRICK_IMU_CALLBACK_QUATERNION] := {$ifdef FPC}@{$endif}CallbackWrapperQuaternion;
end;

procedure TBrickIMU.GetAcceleration(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetMagneticField(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetAngularVelocity(out x: smallint; out y: smallint; out z: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
  z := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetAllData(out accX: smallint; out accY: smallint; out accZ: smallint; out magX: smallint; out magY: smallint; out magZ: smallint; out angX: smallint; out angY: smallint; out angZ: smallint; out temperature: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ALL_DATA, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ALL_DATA, response);
  accX := LEConvertInt16From(4, response);
  accY := LEConvertInt16From(6, response);
  accZ := LEConvertInt16From(8, response);
  magX := LEConvertInt16From(10, response);
  magY := LEConvertInt16From(12, response);
  magZ := LEConvertInt16From(14, response);
  angX := LEConvertInt16From(16, response);
  angY := LEConvertInt16From(18, response);
  angZ := LEConvertInt16From(20, response);
  temperature := LEConvertInt16From(22, response);
end;

procedure TBrickIMU.GetOrientation(out roll: smallint; out pitch: smallint; out yaw: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ORIENTATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ORIENTATION, response);
  roll := LEConvertInt16From(4, response);
  pitch := LEConvertInt16From(6, response);
  yaw := LEConvertInt16From(8, response);
end;

procedure TBrickIMU.GetQuaternion(out x: single; out y: single; out z: single; out w: single);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_QUATERNION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_QUATERNION, response);
  x := LEConvertFloatFrom(4, response);
  y := LEConvertFloatFrom(8, response);
  z := LEConvertFloatFrom(12, response);
  w := LEConvertFloatFrom(16, response);
end;

function TBrickIMU.GetIMUTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_IMU_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickIMU.LedsOn;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_LEDS_ON, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickIMU.LedsOff;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_LEDS_OFF, 4);
  SendRequestNoResponse(request);
end;

function TBrickIMU.AreLedsOn: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_ARE_LEDS_ON, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_ARE_LEDS_ON, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickIMU.SetAccelerationRange(const range: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ACCELERATION_RANGE, 5);
  LEConvertUInt8To(range, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAccelerationRange: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION_RANGE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickIMU.SetMagnetometerRange(const range: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_MAGNETOMETER_RANGE, 5);
  LEConvertUInt8To(range, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetMagnetometerRange: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETOMETER_RANGE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickIMU.SetConvergenceSpeed(const speed: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_CONVERGENCE_SPEED, 6);
  LEConvertUInt16To(speed, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetConvergenceSpeed: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CONVERGENCE_SPEED, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickIMU.SetCalibration(const typ: byte; const data: TArray0To9OfInt16);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_CALIBRATION, 25);
  LEConvertUInt8To(typ, 4, request);
  for i := 0 to Length(data) - 1 do LEConvertInt16To(data[i], 5 + (i * 2), request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetCalibration(const typ: byte): TArray0To9OfInt16;
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CALIBRATION, 5);
  LEConvertUInt8To(typ, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CALIBRATION, response);
  for i := 0 to 9 do result[i] := LEConvertInt16From(4 + (i * 2), response);
end;

procedure TBrickIMU.SetAccelerationPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ACCELERATION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAccelerationPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ACCELERATION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetMagneticFieldPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_MAGNETIC_FIELD_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetMagneticFieldPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_MAGNETIC_FIELD_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetAngularVelocityPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ANGULAR_VELOCITY_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAngularVelocityPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ANGULAR_VELOCITY_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetAllDataPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ALL_DATA_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetAllDataPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ALL_DATA_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetOrientationPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_ORIENTATION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetOrientationPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_ORIENTATION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.SetQuaternionPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_SET_QUATERNION_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetQuaternionPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_QUATERNION_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickIMU.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickIMU.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_IMU_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickIMU.CallbackWrapperAcceleration(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(accelerationCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    accelerationCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperMagneticField(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(magneticFieldCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    magneticFieldCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperAngularVelocity(const packet: TByteArray);
var x: smallint; y: smallint; z: smallint;
begin
  if (Assigned(angularVelocityCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    z := LEConvertInt16From(8, packet);
    angularVelocityCallback(x, y, z);
  end;
end;

procedure TBrickIMU.CallbackWrapperAllData(const packet: TByteArray);
var accX: smallint; accY: smallint; accZ: smallint; magX: smallint; magY: smallint; magZ: smallint; angX: smallint; angY: smallint; angZ: smallint; temperature: smallint;
begin
  if (Assigned(allDataCallback)) then begin
    accX := LEConvertInt16From(4, packet);
    accY := LEConvertInt16From(6, packet);
    accZ := LEConvertInt16From(8, packet);
    magX := LEConvertInt16From(10, packet);
    magY := LEConvertInt16From(12, packet);
    magZ := LEConvertInt16From(14, packet);
    angX := LEConvertInt16From(16, packet);
    angY := LEConvertInt16From(18, packet);
    angZ := LEConvertInt16From(20, packet);
    temperature := LEConvertInt16From(22, packet);
    allDataCallback(accX, accY, accZ, magX, magY, magZ, angX, angY, angZ, temperature);
  end;
end;

procedure TBrickIMU.CallbackWrapperOrientation(const packet: TByteArray);
var roll: smallint; pitch: smallint; yaw: smallint;
begin
  if (Assigned(orientationCallback)) then begin
    roll := LEConvertInt16From(4, packet);
    pitch := LEConvertInt16From(6, packet);
    yaw := LEConvertInt16From(8, packet);
    orientationCallback(roll, pitch, yaw);
  end;
end;

procedure TBrickIMU.CallbackWrapperQuaternion(const packet: TByteArray);
var x: single; y: single; z: single; w: single;
begin
  if (Assigned(quaternionCallback)) then begin
    x := LEConvertFloatFrom(4, packet);
    y := LEConvertFloatFrom(8, packet);
    z := LEConvertFloatFrom(12, packet);
    w := LEConvertFloatFrom(16, packet);
    quaternionCallback(x, y, z, w);
  end;
end;

end.
