{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickMaster;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE = 1;
  BRICK_MASTER_FUNCTION_GET_STACK_CURRENT = 2;
  BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE = 3;
  BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE = 4;
  BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT = 5;
  BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS = 6;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS = 7;
  BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS = 8;
  BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS = 9;
  BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS = 10;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS = 11;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH = 12;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG = 13;
  BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY = 14;
  BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY = 15;
  BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL = 16;
  BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL = 17;
  BRICK_MASTER_FUNCTION_IS_RS485_PRESENT = 18;
  BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS = 19;
  BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS = 20;
  BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS = 21;
  BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS = 22;
  BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG = 23;
  BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION = 24;
  BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION = 25;
  BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT = 26;
  BRICK_MASTER_FUNCTION_SET_WIFI_CONFIGURATION = 27;
  BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION = 28;
  BRICK_MASTER_FUNCTION_SET_WIFI_ENCRYPTION = 29;
  BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION = 30;
  BRICK_MASTER_FUNCTION_GET_WIFI_STATUS = 31;
  BRICK_MASTER_FUNCTION_REFRESH_WIFI_STATUS = 32;
  BRICK_MASTER_FUNCTION_SET_WIFI_CERTIFICATE = 33;
  BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE = 34;
  BRICK_MASTER_FUNCTION_SET_WIFI_POWER_MODE = 35;
  BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE = 36;
  BRICK_MASTER_FUNCTION_RESET = 243;
  BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE = 242;

type
  TArray0To5OfUInt8 = array [0..3] of byte;
  TArray0To3OfUInt8 = array [0..3] of byte;

  TBrickMaster = class(TDevice)
  private
  protected
  public
    constructor Create(const uid_: string);
    function GetStackVoltage: word; virtual;
    function GetStackCurrent: word; virtual;
    procedure SetExtensionType(const extension: byte; const exttype: longword); virtual;
    function GetExtensionType(const extension: byte): longword; virtual;
    function IsChibiPresent: boolean; virtual;
    procedure SetChibiAddress(const address: byte); virtual;
    function GetChibiAddress: byte; virtual;
    procedure SetChibiMasterAddress(const address: byte); virtual;
    function GetChibiMasterAddress: byte; virtual;
    procedure SetChibiSlaveAddress(const num: byte; const address: byte); virtual;
    function GetChibiSlaveAddress(const num: byte): byte; virtual;
    function GetChibiSignalStrength: byte; virtual;
    procedure GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word); virtual;
    procedure SetChibiFrequency(const frequency: byte); virtual;
    function GetChibiFrequency: byte; virtual;
    procedure SetChibiChannel(const channel: byte); virtual;
    function GetChibiChannel: byte; virtual;
    function IsRS485Present: boolean; virtual;
    procedure SetRS485Address(const address: byte); virtual;
    function GetRS485Address: byte; virtual;
    procedure SetRS485SlaveAddress(const num: byte; const address: byte); virtual;
    function GetRS485SlaveAddress(const num: byte): byte; virtual;
    function GetRS485ErrorLog: word; virtual;
    procedure SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte); virtual;
    procedure GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte); virtual;
    function IsWifiPresent: boolean; virtual;
    procedure SetWifiConfiguration(const ssid: string; const connection: byte; const ip: TArray0To3OfUInt8; const subnetMask: TArray0To3OfUInt8; const gateway: TArray0To3OfUInt8; const port: word); virtual;
    procedure GetWifiConfiguration(out ssid: string; out connection: byte; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out port: word); virtual;
    procedure SetWifiEncryption(const encryption: byte; const key: string; const keyIndex: byte; const eapOptions: byte; const caCertificateLength: word; const clientCertificateLength: word; const privateKeyLength: word); virtual;
    procedure GetWifiEncryption(out encryption: byte; out key: string; out keyIndex: byte; out eapOptions: byte; out caCertificateLength: word; out clientCertificateLength: word; out privateKeyLength: word); virtual;
    procedure GetWifiStatus(out macAddress: TArray0To5OfUInt8; out bssid: TArray0To5OfUInt8; out channel: byte; out rssi: smallint; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out rxCount: longword; out txCount: longword; out state: byte); virtual;
    procedure RefreshWifiStatus; virtual;
    procedure SetWifiCertificate(const index: word; const data: string; const dataLength: byte); virtual;
    procedure GetWifiCertificate(const index: word; out data: string; out dataLength: byte); virtual;
    procedure SetWifiPowerMode(const mode: byte); virtual;
    function GetWifiPowerMode: byte; virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
  end;

implementation

constructor TBrickMaster.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Master Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 3;
  bindingVersion[2] := 0;
end;

function TBrickMaster.GetStackVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickMaster.GetStackCurrent: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetExtensionType(const extension: byte; const exttype: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE, 9);
  LEConvertUInt8To(extension, 4, request);
  LEConvertUInt32To(exttype, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetExtensionType(const extension: byte): longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, 5);
  LEConvertUInt8To(extension, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, response);
  result := LEConvertUInt32From(4, response);
end;

function TBrickMaster.IsChibiPresent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetChibiAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiMasterAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiMasterAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiSlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiSlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetChibiSignalStrength: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, response);
  underrun := LEConvertUInt16From(4, response);
  crcError := LEConvertUInt16From(6, response);
  noAck := LEConvertUInt16From(8, response);
  overflow := LEConvertUInt16From(10, response);
end;

procedure TBrickMaster.SetChibiFrequency(const frequency: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY, 5);
  LEConvertUInt8To(frequency, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiFrequency: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiChannel(const channel: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL, 5);
  LEConvertUInt8To(channel, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiChannel: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.IsRS485Present: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetRS485Address(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485Address: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetRS485SlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485SlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetRS485ErrorLog: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION, 10);
  LEConvertUInt32To(speed, 4, request);
  LEConvertCharTo(parity, 8, request);
  LEConvertUInt8To(stopbits, 9, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, response);
  speed := LEConvertUInt32From(4, response);
  parity := LEConvertCharFrom(8, response);
  stopbits := LEConvertUInt8From(9, response);
end;

function TBrickMaster.IsWifiPresent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_WIFI_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetWifiConfiguration(const ssid: string; const connection: byte; const ip: TArray0To3OfUInt8; const subnetMask: TArray0To3OfUInt8; const gateway: TArray0To3OfUInt8; const port: word);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_CONFIGURATION, 51);
  LEConvertStringTo(ssid, 4, 32, request);
  LEConvertUInt8To(connection, 36, request);
  for i := 0 to Length(ip) - 1 do LEConvertUInt8To(ip[i], 37 + (i * 1), request);
  for i := 0 to Length(subnetMask) - 1 do LEConvertUInt8To(subnetMask[i], 41 + (i * 1), request);
  for i := 0 to Length(gateway) - 1 do LEConvertUInt8To(gateway[i], 45 + (i * 1), request);
  LEConvertUInt16To(port, 49, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiConfiguration(out ssid: string; out connection: byte; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out port: word);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_CONFIGURATION, response);
  ssid := LEConvertStringFrom(4, 32, response);
  connection := LEConvertUInt8From(36, response);
  for i := 0 to 3 do ip[i] := LEConvertUInt8From(37 + (i * 1), response);
  for i := 0 to 3 do subnetMask[i] := LEConvertUInt8From(41 + (i * 1), response);
  for i := 0 to 3 do gateway[i] := LEConvertUInt8From(45 + (i * 1), response);
  port := LEConvertUInt16From(49, response);
end;

procedure TBrickMaster.SetWifiEncryption(const encryption: byte; const key: string; const keyIndex: byte; const eapOptions: byte; const caCertificateLength: word; const clientCertificateLength: word; const privateKeyLength: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_ENCRYPTION, 63);
  LEConvertUInt8To(encryption, 4, request);
  LEConvertStringTo(key, 5, 50, request);
  LEConvertUInt8To(keyIndex, 55, request);
  LEConvertUInt8To(eapOptions, 56, request);
  LEConvertUInt16To(caCertificateLength, 57, request);
  LEConvertUInt16To(clientCertificateLength, 59, request);
  LEConvertUInt16To(privateKeyLength, 61, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiEncryption(out encryption: byte; out key: string; out keyIndex: byte; out eapOptions: byte; out caCertificateLength: word; out clientCertificateLength: word; out privateKeyLength: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_ENCRYPTION, response);
  encryption := LEConvertUInt8From(4, response);
  key := LEConvertStringFrom(5, 50, response);
  keyIndex := LEConvertUInt8From(55, response);
  eapOptions := LEConvertUInt8From(56, response);
  caCertificateLength := LEConvertUInt16From(57, response);
  clientCertificateLength := LEConvertUInt16From(59, response);
  privateKeyLength := LEConvertUInt16From(61, response);
end;

procedure TBrickMaster.GetWifiStatus(out macAddress: TArray0To5OfUInt8; out bssid: TArray0To5OfUInt8; out channel: byte; out rssi: smallint; out ip: TArray0To3OfUInt8; out subnetMask: TArray0To3OfUInt8; out gateway: TArray0To3OfUInt8; out rxCount: longword; out txCount: longword; out state: byte);
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_STATUS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_STATUS, response);
  for i := 0 to 5 do macAddress[i] := LEConvertUInt8From(4 + (i * 1), response);
  for i := 0 to 5 do bssid[i] := LEConvertUInt8From(10 + (i * 1), response);
  channel := LEConvertUInt8From(16, response);
  rssi := LEConvertInt16From(17, response);
  for i := 0 to 3 do ip[i] := LEConvertUInt8From(19 + (i * 1), response);
  for i := 0 to 3 do subnetMask[i] := LEConvertUInt8From(23 + (i * 1), response);
  for i := 0 to 3 do gateway[i] := LEConvertUInt8From(27 + (i * 1), response);
  rxCount := LEConvertUInt32From(31, response);
  txCount := LEConvertUInt32From(35, response);
  state := LEConvertUInt8From(39, response);
end;

procedure TBrickMaster.RefreshWifiStatus;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_REFRESH_WIFI_STATUS, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.SetWifiCertificate(const index: word; const data: string; const dataLength: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_CERTIFICATE, 39);
  LEConvertUInt16To(index, 4, request);
  LEConvertStringTo(data, 6, 32, request);
  LEConvertUInt8To(dataLength, 38, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetWifiCertificate(const index: word; out data: string; out dataLength: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE, 6);
  LEConvertUInt16To(index, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_CERTIFICATE, response);
  data := LEConvertStringFrom(4, 32, response);
  dataLength := LEConvertUInt8From(36, response);
end;

procedure TBrickMaster.SetWifiPowerMode(const mode: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_WIFI_POWER_MODE, 5);
  LEConvertUInt8To(mode, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetWifiPowerMode: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_WIFI_POWER_MODE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

end.
