{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickServo;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_SERVO_FUNCTION_ENABLE = 1;
  BRICK_SERVO_FUNCTION_DISABLE = 2;
  BRICK_SERVO_FUNCTION_IS_ENABLED = 3;
  BRICK_SERVO_FUNCTION_SET_POSITION = 4;
  BRICK_SERVO_FUNCTION_GET_POSITION = 5;
  BRICK_SERVO_FUNCTION_GET_CURRENT_POSITION = 6;
  BRICK_SERVO_FUNCTION_SET_VELOCITY = 7;
  BRICK_SERVO_FUNCTION_GET_VELOCITY = 8;
  BRICK_SERVO_FUNCTION_GET_CURRENT_VELOCITY = 9;
  BRICK_SERVO_FUNCTION_SET_ACCELERATION = 10;
  BRICK_SERVO_FUNCTION_GET_ACCELERATION = 11;
  BRICK_SERVO_FUNCTION_SET_OUTPUT_VOLTAGE = 12;
  BRICK_SERVO_FUNCTION_GET_OUTPUT_VOLTAGE = 13;
  BRICK_SERVO_FUNCTION_SET_PULSE_WIDTH = 14;
  BRICK_SERVO_FUNCTION_GET_PULSE_WIDTH = 15;
  BRICK_SERVO_FUNCTION_SET_DEGREE = 16;
  BRICK_SERVO_FUNCTION_GET_DEGREE = 17;
  BRICK_SERVO_FUNCTION_SET_PERIOD = 18;
  BRICK_SERVO_FUNCTION_GET_PERIOD = 19;
  BRICK_SERVO_FUNCTION_GET_SERVO_CURRENT = 20;
  BRICK_SERVO_FUNCTION_GET_OVERALL_CURRENT = 21;
  BRICK_SERVO_FUNCTION_GET_STACK_INPUT_VOLTAGE = 22;
  BRICK_SERVO_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 23;
  BRICK_SERVO_FUNCTION_SET_MINIMUM_VOLTAGE = 24;
  BRICK_SERVO_FUNCTION_GET_MINIMUM_VOLTAGE = 25;
  BRICK_SERVO_FUNCTION_RESET = 243;
  BRICK_SERVO_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICK_SERVO_CALLBACK_UNDER_VOLTAGE = 26;
  BRICK_SERVO_CALLBACK_POSITION_REACHED = 27;
  BRICK_SERVO_CALLBACK_VELOCITY_REACHED = 28;

type
  TBrickServoNotifyUnderVoltage = procedure(const voltage: word) of object;
  TBrickServoNotifyPositionReached = procedure(const servoNum: byte; const position: smallint) of object;
  TBrickServoNotifyVelocityReached = procedure(const servoNum: byte; const velocity: smallint) of object;

  TBrickServo = class(TDevice)
  private
    underVoltageCallback: TBrickServoNotifyUnderVoltage;
    positionReachedCallback: TBrickServoNotifyPositionReached;
    velocityReachedCallback: TBrickServoNotifyVelocityReached;
  protected
    procedure CallbackWrapperUnderVoltage(const packet: TByteArray); virtual;
    procedure CallbackWrapperPositionReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperVelocityReached(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure Enable(const servoNum: byte); virtual;
    procedure Disable(const servoNum: byte); virtual;
    function IsEnabled(const servoNum: byte): boolean; virtual;
    procedure SetPosition(const servoNum: byte; const position: smallint); virtual;
    function GetPosition(const servoNum: byte): smallint; virtual;
    function GetCurrentPosition(const servoNum: byte): smallint; virtual;
    procedure SetVelocity(const servoNum: byte; const velocity: word); virtual;
    function GetVelocity(const servoNum: byte): word; virtual;
    function GetCurrentVelocity(const servoNum: byte): word; virtual;
    procedure SetAcceleration(const servoNum: byte; const acceleration: word); virtual;
    function GetAcceleration(const servoNum: byte): word; virtual;
    procedure SetOutputVoltage(const voltage: word); virtual;
    function GetOutputVoltage: word; virtual;
    procedure SetPulseWidth(const servoNum: byte; const min: word; const max: word); virtual;
    procedure GetPulseWidth(const servoNum: byte; out min: word; out max: word); virtual;
    procedure SetDegree(const servoNum: byte; const min: smallint; const max: smallint); virtual;
    procedure GetDegree(const servoNum: byte; out min: smallint; out max: smallint); virtual;
    procedure SetPeriod(const servoNum: byte; const period: word); virtual;
    function GetPeriod(const servoNum: byte): word; virtual;
    function GetServoCurrent(const servoNum: byte): word; virtual;
    function GetOverallCurrent: word; virtual;
    function GetStackInputVoltage: word; virtual;
    function GetExternalInputVoltage: word; virtual;
    procedure SetMinimumVoltage(const voltage: word); virtual;
    function GetMinimumVoltage: word; virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
    property OnUnderVoltage: TBrickServoNotifyUnderVoltage read underVoltageCallback write underVoltageCallback;
    property OnPositionReached: TBrickServoNotifyPositionReached read positionReachedCallback write positionReachedCallback;
    property OnVelocityReached: TBrickServoNotifyVelocityReached read velocityReachedCallback write velocityReachedCallback;
  end;

implementation

constructor TBrickServo.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Servo Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICK_SERVO_CALLBACK_UNDER_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperUnderVoltage;
  callbackWrappers[BRICK_SERVO_CALLBACK_POSITION_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperPositionReached;
  callbackWrappers[BRICK_SERVO_CALLBACK_VELOCITY_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVelocityReached;
end;

procedure TBrickServo.Enable(const servoNum: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_ENABLE, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SendRequestNoResponse(request);
end;

procedure TBrickServo.Disable(const servoNum: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_DISABLE, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.IsEnabled(const servoNum: byte): boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_IS_ENABLED, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_IS_ENABLED, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickServo.SetPosition(const servoNum: byte; const position: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_POSITION, 7);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertInt16To(position, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetPosition(const servoNum: byte): smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_POSITION, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_POSITION, response);
  result := LEConvertInt16From(4, response);
end;

function TBrickServo.GetCurrentPosition(const servoNum: byte): smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_CURRENT_POSITION, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_CURRENT_POSITION, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickServo.SetVelocity(const servoNum: byte; const velocity: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_VELOCITY, 7);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertUInt16To(velocity, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetVelocity(const servoNum: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_VELOCITY, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_VELOCITY, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickServo.GetCurrentVelocity(const servoNum: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_CURRENT_VELOCITY, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_CURRENT_VELOCITY, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickServo.SetAcceleration(const servoNum: byte; const acceleration: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_ACCELERATION, 7);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertUInt16To(acceleration, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetAcceleration(const servoNum: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_ACCELERATION, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_ACCELERATION, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickServo.SetOutputVoltage(const voltage: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_OUTPUT_VOLTAGE, 6);
  LEConvertUInt16To(voltage, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetOutputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_OUTPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_OUTPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickServo.SetPulseWidth(const servoNum: byte; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_PULSE_WIDTH, 9);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickServo.GetPulseWidth(const servoNum: byte; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_PULSE_WIDTH, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_PULSE_WIDTH, response);
  min := LEConvertUInt16From(4, response);
  max := LEConvertUInt16From(6, response);
end;

procedure TBrickServo.SetDegree(const servoNum: byte; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_DEGREE, 9);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickServo.GetDegree(const servoNum: byte; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_DEGREE, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_DEGREE, response);
  min := LEConvertInt16From(4, response);
  max := LEConvertInt16From(6, response);
end;

procedure TBrickServo.SetPeriod(const servoNum: byte; const period: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_PERIOD, 7);
  LEConvertUInt8To(servoNum, 4, request);
  LEConvertUInt16To(period, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetPeriod(const servoNum: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_PERIOD, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_PERIOD, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickServo.GetServoCurrent(const servoNum: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_SERVO_CURRENT, 5);
  LEConvertUInt8To(servoNum, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_SERVO_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickServo.GetOverallCurrent: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_OVERALL_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_OVERALL_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickServo.GetStackInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_STACK_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_STACK_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickServo.GetExternalInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickServo.SetMinimumVoltage(const voltage: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_SET_MINIMUM_VOLTAGE, 6);
  LEConvertUInt16To(voltage, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetMinimumVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_MINIMUM_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_MINIMUM_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickServo.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickServo.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_SERVO_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_SERVO_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickServo.CallbackWrapperUnderVoltage(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(underVoltageCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    underVoltageCallback(voltage);
  end;
end;

procedure TBrickServo.CallbackWrapperPositionReached(const packet: TByteArray);
var servoNum: byte; position: smallint;
begin
  if (Assigned(positionReachedCallback)) then begin
    servoNum := LEConvertUInt8From(4, packet);
    position := LEConvertInt16From(5, packet);
    positionReachedCallback(servoNum, position);
  end;
end;

procedure TBrickServo.CallbackWrapperVelocityReached(const packet: TByteArray);
var servoNum: byte; velocity: smallint;
begin
  if (Assigned(velocityReachedCallback)) then begin
    servoNum := LEConvertUInt8From(4, packet);
    velocity := LEConvertInt16From(5, packet);
    velocityReachedCallback(servoNum, velocity);
  end;
end;

end.
