{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickStepper;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_STEPPER_FUNCTION_SET_MAX_VELOCITY = 1;
  BRICK_STEPPER_FUNCTION_GET_MAX_VELOCITY = 2;
  BRICK_STEPPER_FUNCTION_GET_CURRENT_VELOCITY = 3;
  BRICK_STEPPER_FUNCTION_SET_SPEED_RAMPING = 4;
  BRICK_STEPPER_FUNCTION_GET_SPEED_RAMPING = 5;
  BRICK_STEPPER_FUNCTION_FULL_BRAKE = 6;
  BRICK_STEPPER_FUNCTION_SET_CURRENT_POSITION = 7;
  BRICK_STEPPER_FUNCTION_GET_CURRENT_POSITION = 8;
  BRICK_STEPPER_FUNCTION_SET_TARGET_POSITION = 9;
  BRICK_STEPPER_FUNCTION_GET_TARGET_POSITION = 10;
  BRICK_STEPPER_FUNCTION_SET_STEPS = 11;
  BRICK_STEPPER_FUNCTION_GET_STEPS = 12;
  BRICK_STEPPER_FUNCTION_GET_REMAINING_STEPS = 13;
  BRICK_STEPPER_FUNCTION_SET_STEP_MODE = 14;
  BRICK_STEPPER_FUNCTION_GET_STEP_MODE = 15;
  BRICK_STEPPER_FUNCTION_DRIVE_FORWARD = 16;
  BRICK_STEPPER_FUNCTION_DRIVE_BACKWARD = 17;
  BRICK_STEPPER_FUNCTION_STOP = 18;
  BRICK_STEPPER_FUNCTION_GET_STACK_INPUT_VOLTAGE = 19;
  BRICK_STEPPER_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE = 20;
  BRICK_STEPPER_FUNCTION_GET_CURRENT_CONSUMPTION = 21;
  BRICK_STEPPER_FUNCTION_SET_MOTOR_CURRENT = 22;
  BRICK_STEPPER_FUNCTION_GET_MOTOR_CURRENT = 23;
  BRICK_STEPPER_FUNCTION_ENABLE = 24;
  BRICK_STEPPER_FUNCTION_DISABLE = 25;
  BRICK_STEPPER_FUNCTION_IS_ENABLED = 26;
  BRICK_STEPPER_FUNCTION_SET_DECAY = 27;
  BRICK_STEPPER_FUNCTION_GET_DECAY = 28;
  BRICK_STEPPER_FUNCTION_SET_MINIMUM_VOLTAGE = 29;
  BRICK_STEPPER_FUNCTION_GET_MINIMUM_VOLTAGE = 30;
  BRICK_STEPPER_FUNCTION_SET_SYNC_RECT = 33;
  BRICK_STEPPER_FUNCTION_IS_SYNC_RECT = 34;
  BRICK_STEPPER_FUNCTION_SET_TIME_BASE = 35;
  BRICK_STEPPER_FUNCTION_GET_TIME_BASE = 36;
  BRICK_STEPPER_FUNCTION_GET_ALL_DATA = 37;
  BRICK_STEPPER_FUNCTION_SET_ALL_DATA_PERIOD = 38;
  BRICK_STEPPER_FUNCTION_GET_ALL_DATA_PERIOD = 39;
  BRICK_STEPPER_FUNCTION_RESET = 243;
  BRICK_STEPPER_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICK_STEPPER_CALLBACK_UNDER_VOLTAGE = 31;
  BRICK_STEPPER_CALLBACK_POSITION_REACHED = 32;
  BRICK_STEPPER_CALLBACK_ALL_DATA = 40;
  BRICK_STEPPER_CALLBACK_NEW_STATE = 41;

type
  TBrickStepperNotifyUnderVoltage = procedure(const voltage: word) of object;
  TBrickStepperNotifyPositionReached = procedure(const position: longint) of object;
  TBrickStepperNotifyAllData = procedure(const currentVelocity: word; const currentPosition: longint; const remainingSteps: longint; const stackVoltage: word; const externalVoltage: word; const currentConsumption: word) of object;
  TBrickStepperNotifyNewState = procedure(const stateNew: byte; const statePrevious: byte) of object;

  TBrickStepper = class(TDevice)
  private
    underVoltageCallback: TBrickStepperNotifyUnderVoltage;
    positionReachedCallback: TBrickStepperNotifyPositionReached;
    allDataCallback: TBrickStepperNotifyAllData;
    newStateCallback: TBrickStepperNotifyNewState;
  protected
    procedure CallbackWrapperUnderVoltage(const packet: TByteArray); virtual;
    procedure CallbackWrapperPositionReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAllData(const packet: TByteArray); virtual;
    procedure CallbackWrapperNewState(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure SetMaxVelocity(const velocity: word); virtual;
    function GetMaxVelocity: word; virtual;
    function GetCurrentVelocity: word; virtual;
    procedure SetSpeedRamping(const acceleration: word; const deacceleration: word); virtual;
    procedure GetSpeedRamping(out acceleration: word; out deacceleration: word); virtual;
    procedure FullBrake; virtual;
    procedure SetCurrentPosition(const position: longint); virtual;
    function GetCurrentPosition: longint; virtual;
    procedure SetTargetPosition(const position: longint); virtual;
    function GetTargetPosition: longint; virtual;
    procedure SetSteps(const steps: longint); virtual;
    function GetSteps: longint; virtual;
    function GetRemainingSteps: longint; virtual;
    procedure SetStepMode(const mode: byte); virtual;
    function GetStepMode: byte; virtual;
    procedure DriveForward; virtual;
    procedure DriveBackward; virtual;
    procedure Stop; virtual;
    function GetStackInputVoltage: word; virtual;
    function GetExternalInputVoltage: word; virtual;
    function GetCurrentConsumption: word; virtual;
    procedure SetMotorCurrent(const current: word); virtual;
    function GetMotorCurrent: word; virtual;
    procedure Enable; virtual;
    procedure Disable; virtual;
    function IsEnabled: boolean; virtual;
    procedure SetDecay(const decay: word); virtual;
    function GetDecay: word; virtual;
    procedure SetMinimumVoltage(const voltage: word); virtual;
    function GetMinimumVoltage: word; virtual;
    procedure SetSyncRect(const syncRect: boolean); virtual;
    function IsSyncRect: boolean; virtual;
    procedure SetTimeBase(const timeBase: longword); virtual;
    function GetTimeBase: longword; virtual;
    procedure GetAllData(out currentVelocity: word; out currentPosition: longint; out remainingSteps: longint; out stackVoltage: word; out externalVoltage: word; out currentConsumption: word); virtual;
    procedure SetAllDataPeriod(const period: longword); virtual;
    function GetAllDataPeriod: longword; virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
    property OnUnderVoltage: TBrickStepperNotifyUnderVoltage read underVoltageCallback write underVoltageCallback;
    property OnPositionReached: TBrickStepperNotifyPositionReached read positionReachedCallback write positionReachedCallback;
    property OnAllData: TBrickStepperNotifyAllData read allDataCallback write allDataCallback;
    property OnNewState: TBrickStepperNotifyNewState read newStateCallback write newStateCallback;
  end;

implementation

constructor TBrickStepper.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Stepper Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 2;
  callbackWrappers[BRICK_STEPPER_CALLBACK_UNDER_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperUnderVoltage;
  callbackWrappers[BRICK_STEPPER_CALLBACK_POSITION_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperPositionReached;
  callbackWrappers[BRICK_STEPPER_CALLBACK_ALL_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperAllData;
  callbackWrappers[BRICK_STEPPER_CALLBACK_NEW_STATE] := {$ifdef FPC}@{$endif}CallbackWrapperNewState;
end;

procedure TBrickStepper.SetMaxVelocity(const velocity: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_MAX_VELOCITY, 6);
  LEConvertUInt16To(velocity, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetMaxVelocity: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_MAX_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_MAX_VELOCITY, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickStepper.GetCurrentVelocity: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_CURRENT_VELOCITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_CURRENT_VELOCITY, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickStepper.SetSpeedRamping(const acceleration: word; const deacceleration: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_SPEED_RAMPING, 8);
  LEConvertUInt16To(acceleration, 4, request);
  LEConvertUInt16To(deacceleration, 6, request);
  SendRequestNoResponse(request);
end;

procedure TBrickStepper.GetSpeedRamping(out acceleration: word; out deacceleration: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_SPEED_RAMPING, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_SPEED_RAMPING, response);
  acceleration := LEConvertUInt16From(4, response);
  deacceleration := LEConvertUInt16From(6, response);
end;

procedure TBrickStepper.FullBrake;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_FULL_BRAKE, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickStepper.SetCurrentPosition(const position: longint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_CURRENT_POSITION, 8);
  LEConvertInt32To(position, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetCurrentPosition: longint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_CURRENT_POSITION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_CURRENT_POSITION, response);
  result := LEConvertInt32From(4, response);
end;

procedure TBrickStepper.SetTargetPosition(const position: longint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_TARGET_POSITION, 8);
  LEConvertInt32To(position, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetTargetPosition: longint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_TARGET_POSITION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_TARGET_POSITION, response);
  result := LEConvertInt32From(4, response);
end;

procedure TBrickStepper.SetSteps(const steps: longint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_STEPS, 8);
  LEConvertInt32To(steps, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetSteps: longint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_STEPS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_STEPS, response);
  result := LEConvertInt32From(4, response);
end;

function TBrickStepper.GetRemainingSteps: longint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_REMAINING_STEPS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_REMAINING_STEPS, response);
  result := LEConvertInt32From(4, response);
end;

procedure TBrickStepper.SetStepMode(const mode: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_STEP_MODE, 5);
  LEConvertUInt8To(mode, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetStepMode: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_STEP_MODE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_STEP_MODE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickStepper.DriveForward;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_DRIVE_FORWARD, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickStepper.DriveBackward;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_DRIVE_BACKWARD, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickStepper.Stop;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_STOP, 4);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetStackInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_STACK_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_STACK_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickStepper.GetExternalInputVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_EXTERNAL_INPUT_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickStepper.GetCurrentConsumption: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_CURRENT_CONSUMPTION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_CURRENT_CONSUMPTION, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickStepper.SetMotorCurrent(const current: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_MOTOR_CURRENT, 6);
  LEConvertUInt16To(current, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetMotorCurrent: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_MOTOR_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_MOTOR_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickStepper.Enable;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_ENABLE, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickStepper.Disable;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_DISABLE, 4);
  SendRequestNoResponse(request);
end;

function TBrickStepper.IsEnabled: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_IS_ENABLED, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_IS_ENABLED, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickStepper.SetDecay(const decay: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_DECAY, 6);
  LEConvertUInt16To(decay, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetDecay: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_DECAY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_DECAY, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickStepper.SetMinimumVoltage(const voltage: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_MINIMUM_VOLTAGE, 6);
  LEConvertUInt16To(voltage, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetMinimumVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_MINIMUM_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_MINIMUM_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickStepper.SetSyncRect(const syncRect: boolean);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_SYNC_RECT, 5);
  LEConvertBooleanTo(syncRect, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.IsSyncRect: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_IS_SYNC_RECT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_IS_SYNC_RECT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickStepper.SetTimeBase(const timeBase: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_TIME_BASE, 8);
  LEConvertUInt32To(timeBase, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetTimeBase: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_TIME_BASE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_TIME_BASE, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickStepper.GetAllData(out currentVelocity: word; out currentPosition: longint; out remainingSteps: longint; out stackVoltage: word; out externalVoltage: word; out currentConsumption: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_ALL_DATA, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_ALL_DATA, response);
  currentVelocity := LEConvertUInt16From(4, response);
  currentPosition := LEConvertInt32From(6, response);
  remainingSteps := LEConvertInt32From(10, response);
  stackVoltage := LEConvertUInt16From(14, response);
  externalVoltage := LEConvertUInt16From(16, response);
  currentConsumption := LEConvertUInt16From(18, response);
end;

procedure TBrickStepper.SetAllDataPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_SET_ALL_DATA_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetAllDataPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_ALL_DATA_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_ALL_DATA_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickStepper.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickStepper.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_STEPPER_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_STEPPER_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickStepper.CallbackWrapperUnderVoltage(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(underVoltageCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    underVoltageCallback(voltage);
  end;
end;

procedure TBrickStepper.CallbackWrapperPositionReached(const packet: TByteArray);
var position: longint;
begin
  if (Assigned(positionReachedCallback)) then begin
    position := LEConvertInt32From(4, packet);
    positionReachedCallback(position);
  end;
end;

procedure TBrickStepper.CallbackWrapperAllData(const packet: TByteArray);
var currentVelocity: word; currentPosition: longint; remainingSteps: longint; stackVoltage: word; externalVoltage: word; currentConsumption: word;
begin
  if (Assigned(allDataCallback)) then begin
    currentVelocity := LEConvertUInt16From(4, packet);
    currentPosition := LEConvertInt32From(6, packet);
    remainingSteps := LEConvertInt32From(10, packet);
    stackVoltage := LEConvertUInt16From(14, packet);
    externalVoltage := LEConvertUInt16From(16, packet);
    currentConsumption := LEConvertUInt16From(18, packet);
    allDataCallback(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption);
  end;
end;

procedure TBrickStepper.CallbackWrapperNewState(const packet: TByteArray);
var stateNew: byte; statePrevious: byte;
begin
  if (Assigned(newStateCallback)) then begin
    stateNew := LEConvertUInt8From(4, packet);
    statePrevious := LEConvertUInt8From(5, packet);
    newStateCallback(stateNew, statePrevious);
  end;
end;

end.
