{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletAmbientLight;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE = 1;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD = 3;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD = 4;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD = 7;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD = 8;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_AMBIENT_LIGHT_CALLBACK_ILLUMINANCE = 13;
  BRICKLET_AMBIENT_LIGHT_CALLBACK_ANALOG_VALUE = 14;
  BRICKLET_AMBIENT_LIGHT_CALLBACK_ILLUMINANCE_REACHED = 15;
  BRICKLET_AMBIENT_LIGHT_CALLBACK_ANALOG_VALUE_REACHED = 16;

type
  TBrickletAmbientLightNotifyIlluminance = procedure(const illuminance: word) of object;
  TBrickletAmbientLightNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletAmbientLightNotifyIlluminanceReached = procedure(const illuminance: word) of object;
  TBrickletAmbientLightNotifyAnalogValueReached = procedure(const value: word) of object;

  TBrickletAmbientLight = class(TDevice)
  private
    illuminanceCallback: TBrickletAmbientLightNotifyIlluminance;
    analogValueCallback: TBrickletAmbientLightNotifyAnalogValue;
    illuminanceReachedCallback: TBrickletAmbientLightNotifyIlluminanceReached;
    analogValueReachedCallback: TBrickletAmbientLightNotifyAnalogValueReached;
  protected
    procedure CallbackWrapperIlluminance(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperIlluminanceReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    function GetIlluminance: word; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetIlluminanceCallbackPeriod(const period: longword); virtual;
    function GetIlluminanceCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetIlluminanceCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetIlluminanceCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnIlluminance: TBrickletAmbientLightNotifyIlluminance read illuminanceCallback write illuminanceCallback;
    property OnAnalogValue: TBrickletAmbientLightNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnIlluminanceReached: TBrickletAmbientLightNotifyIlluminanceReached read illuminanceReachedCallback write illuminanceReachedCallback;
    property OnAnalogValueReached: TBrickletAmbientLightNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletAmbientLight.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Ambient Light Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_AMBIENT_LIGHT_CALLBACK_ILLUMINANCE] := {$ifdef FPC}@{$endif}CallbackWrapperIlluminance;
  callbackWrappers[BRICKLET_AMBIENT_LIGHT_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_AMBIENT_LIGHT_CALLBACK_ILLUMINANCE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperIlluminanceReached;
  callbackWrappers[BRICKLET_AMBIENT_LIGHT_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletAmbientLight.GetIlluminance: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickletAmbientLight.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletAmbientLight.SetIlluminanceCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ILLUMINANCE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAmbientLight.GetIlluminanceCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAmbientLight.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAmbientLight.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAmbientLight.SetIlluminanceCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ILLUMINANCE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletAmbientLight.GetIlluminanceCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ILLUMINANCE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletAmbientLight.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletAmbientLight.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletAmbientLight.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAmbientLight.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_AMBIENT_LIGHT_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAmbientLight.CallbackWrapperIlluminance(const packet: TByteArray);
var illuminance: word;
begin
  if (Assigned(illuminanceCallback)) then begin
    illuminance := LEConvertUInt16From(4, packet);
    illuminanceCallback(illuminance);
  end;
end;

procedure TBrickletAmbientLight.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletAmbientLight.CallbackWrapperIlluminanceReached(const packet: TByteArray);
var illuminance: word;
begin
  if (Assigned(illuminanceReachedCallback)) then begin
    illuminance := LEConvertUInt16From(4, packet);
    illuminanceReachedCallback(illuminance);
  end;
end;

procedure TBrickletAmbientLight.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
