{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletAnalogOut;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_ANALOG_OUT_FUNCTION_SET_VOLTAGE = 1;
  BRICKLET_ANALOG_OUT_FUNCTION_GET_VOLTAGE = 2;
  BRICKLET_ANALOG_OUT_FUNCTION_SET_MODE = 3;
  BRICKLET_ANALOG_OUT_FUNCTION_GET_MODE = 4;

type
  TBrickletAnalogOut = class(TDevice)
  private
  protected
  public
    constructor Create(const uid_: string);
    procedure SetVoltage(const voltage: word); virtual;
    function GetVoltage: word; virtual;
    procedure SetMode(const mode: byte); virtual;
    function GetMode: byte; virtual;
  end;

implementation

constructor TBrickletAnalogOut.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Analog Out Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
end;

procedure TBrickletAnalogOut.SetVoltage(const voltage: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_OUT_FUNCTION_SET_VOLTAGE, 6);
  LEConvertUInt16To(voltage, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAnalogOut.GetVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_OUT_FUNCTION_GET_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_OUT_FUNCTION_GET_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletAnalogOut.SetMode(const mode: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_OUT_FUNCTION_SET_MODE, 5);
  LEConvertUInt8To(mode, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAnalogOut.GetMode: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_OUT_FUNCTION_GET_MODE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_OUT_FUNCTION_GET_MODE, response);
  result := LEConvertUInt8From(4, response);
end;

end.
