{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletIO16;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_IO16_FUNCTION_SET_PORT = 1;
  BRICKLET_IO16_FUNCTION_GET_PORT = 2;
  BRICKLET_IO16_FUNCTION_SET_PORT_CONFIGURATION = 3;
  BRICKLET_IO16_FUNCTION_GET_PORT_CONFIGURATION = 4;
  BRICKLET_IO16_FUNCTION_SET_DEBOUNCE_PERIOD = 5;
  BRICKLET_IO16_FUNCTION_GET_DEBOUNCE_PERIOD = 6;
  BRICKLET_IO16_FUNCTION_SET_PORT_INTERRUPT = 7;
  BRICKLET_IO16_FUNCTION_GET_PORT_INTERRUPT = 8;
  BRICKLET_IO16_FUNCTION_SET_PORT_MONOFLOP = 10;
  BRICKLET_IO16_FUNCTION_GET_PORT_MONOFLOP = 11;
  BRICKLET_IO16_CALLBACK_INTERRUPT = 9;
  BRICKLET_IO16_CALLBACK_MONOFLOP_DONE = 12;

type
  TBrickletIO16NotifyInterrupt = procedure(const port: char; const interruptMask: byte; const valueMask: byte) of object;
  TBrickletIO16NotifyMonoflopDone = procedure(const port: char; const pinMask: byte; const valueMask: byte) of object;

  TBrickletIO16 = class(TDevice)
  private
    interruptCallback: TBrickletIO16NotifyInterrupt;
    monoflopDoneCallback: TBrickletIO16NotifyMonoflopDone;
  protected
    procedure CallbackWrapperInterrupt(const packet: TByteArray); virtual;
    procedure CallbackWrapperMonoflopDone(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure SetPort(const port: char; const valueMask: byte); virtual;
    function GetPort(const port: char): byte; virtual;
    procedure SetPortConfiguration(const port: char; const pinMask: byte; const direction: char; const value: boolean); virtual;
    procedure GetPortConfiguration(const port: char; out directionMask: byte; out valueMask: byte); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    procedure SetPortInterrupt(const port: char; const interruptMask: byte); virtual;
    function GetPortInterrupt(const port: char): byte; virtual;
    procedure SetPortMonoflop(const port: char; const pinMask: byte; const valueMask: byte; const time: longword); virtual;
    procedure GetPortMonoflop(const port: char; const pin: byte; out value: byte; out time: longword; out timeRemaining: longword); virtual;
    property OnInterrupt: TBrickletIO16NotifyInterrupt read interruptCallback write interruptCallback;
    property OnMonoflopDone: TBrickletIO16NotifyMonoflopDone read monoflopDoneCallback write monoflopDoneCallback;
  end;

implementation

constructor TBrickletIO16.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'IO-16 Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICKLET_IO16_CALLBACK_INTERRUPT] := {$ifdef FPC}@{$endif}CallbackWrapperInterrupt;
  callbackWrappers[BRICKLET_IO16_CALLBACK_MONOFLOP_DONE] := {$ifdef FPC}@{$endif}CallbackWrapperMonoflopDone;
end;

procedure TBrickletIO16.SetPort(const port: char; const valueMask: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_SET_PORT, 6);
  LEConvertCharTo(port, 4, request);
  LEConvertUInt8To(valueMask, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO16.GetPort(const port: char): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_GET_PORT, 5);
  LEConvertCharTo(port, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO16_FUNCTION_GET_PORT, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickletIO16.SetPortConfiguration(const port: char; const pinMask: byte; const direction: char; const value: boolean);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_SET_PORT_CONFIGURATION, 8);
  LEConvertCharTo(port, 4, request);
  LEConvertUInt8To(pinMask, 5, request);
  LEConvertCharTo(direction, 6, request);
  LEConvertBooleanTo(value, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletIO16.GetPortConfiguration(const port: char; out directionMask: byte; out valueMask: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_GET_PORT_CONFIGURATION, 5);
  LEConvertCharTo(port, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO16_FUNCTION_GET_PORT_CONFIGURATION, response);
  directionMask := LEConvertUInt8From(4, response);
  valueMask := LEConvertUInt8From(5, response);
end;

procedure TBrickletIO16.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO16.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO16_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletIO16.SetPortInterrupt(const port: char; const interruptMask: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_SET_PORT_INTERRUPT, 6);
  LEConvertCharTo(port, 4, request);
  LEConvertUInt8To(interruptMask, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO16.GetPortInterrupt(const port: char): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_GET_PORT_INTERRUPT, 5);
  LEConvertCharTo(port, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO16_FUNCTION_GET_PORT_INTERRUPT, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickletIO16.SetPortMonoflop(const port: char; const pinMask: byte; const valueMask: byte; const time: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_SET_PORT_MONOFLOP, 11);
  LEConvertCharTo(port, 4, request);
  LEConvertUInt8To(pinMask, 5, request);
  LEConvertUInt8To(valueMask, 6, request);
  LEConvertUInt32To(time, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletIO16.GetPortMonoflop(const port: char; const pin: byte; out value: byte; out time: longword; out timeRemaining: longword);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO16_FUNCTION_GET_PORT_MONOFLOP, 6);
  LEConvertCharTo(port, 4, request);
  LEConvertUInt8To(pin, 5, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO16_FUNCTION_GET_PORT_MONOFLOP, response);
  value := LEConvertUInt8From(4, response);
  time := LEConvertUInt32From(5, response);
  timeRemaining := LEConvertUInt32From(9, response);
end;

procedure TBrickletIO16.CallbackWrapperInterrupt(const packet: TByteArray);
var port: char; interruptMask: byte; valueMask: byte;
begin
  if (Assigned(interruptCallback)) then begin
    port := LEConvertCharFrom(4, packet);
    interruptMask := LEConvertUInt8From(5, packet);
    valueMask := LEConvertUInt8From(6, packet);
    interruptCallback(port, interruptMask, valueMask);
  end;
end;

procedure TBrickletIO16.CallbackWrapperMonoflopDone(const packet: TByteArray);
var port: char; pinMask: byte; valueMask: byte;
begin
  if (Assigned(monoflopDoneCallback)) then begin
    port := LEConvertCharFrom(4, packet);
    pinMask := LEConvertUInt8From(5, packet);
    valueMask := LEConvertUInt8From(6, packet);
    monoflopDoneCallback(port, pinMask, valueMask);
  end;
end;

end.
