{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletIO4;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_IO4_FUNCTION_SET_VALUE = 1;
  BRICKLET_IO4_FUNCTION_GET_VALUE = 2;
  BRICKLET_IO4_FUNCTION_SET_CONFIGURATION = 3;
  BRICKLET_IO4_FUNCTION_GET_CONFIGURATION = 4;
  BRICKLET_IO4_FUNCTION_SET_DEBOUNCE_PERIOD = 5;
  BRICKLET_IO4_FUNCTION_GET_DEBOUNCE_PERIOD = 6;
  BRICKLET_IO4_FUNCTION_SET_INTERRUPT = 7;
  BRICKLET_IO4_FUNCTION_GET_INTERRUPT = 8;
  BRICKLET_IO4_FUNCTION_SET_MONOFLOP = 10;
  BRICKLET_IO4_FUNCTION_GET_MONOFLOP = 11;
  BRICKLET_IO4_CALLBACK_INTERRUPT = 9;
  BRICKLET_IO4_CALLBACK_MONOFLOP_DONE = 12;

type
  TBrickletIO4NotifyInterrupt = procedure(const interruptMask: byte; const valueMask: byte) of object;
  TBrickletIO4NotifyMonoflopDone = procedure(const pinMask: byte; const valueMask: byte) of object;

  TBrickletIO4 = class(TDevice)
  private
    interruptCallback: TBrickletIO4NotifyInterrupt;
    monoflopDoneCallback: TBrickletIO4NotifyMonoflopDone;
  protected
    procedure CallbackWrapperInterrupt(const packet: TByteArray); virtual;
    procedure CallbackWrapperMonoflopDone(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure SetValue(const valueMask: byte); virtual;
    function GetValue: byte; virtual;
    procedure SetConfiguration(const pinMask: byte; const direction: char; const value: boolean); virtual;
    procedure GetConfiguration(out directionMask: byte; out valueMask: byte); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    procedure SetInterrupt(const interruptMask: byte); virtual;
    function GetInterrupt: byte; virtual;
    procedure SetMonoflop(const pinMask: byte; const valueMask: byte; const time: longword); virtual;
    procedure GetMonoflop(const pin: byte; out value: byte; out time: longword; out timeRemaining: longword); virtual;
    property OnInterrupt: TBrickletIO4NotifyInterrupt read interruptCallback write interruptCallback;
    property OnMonoflopDone: TBrickletIO4NotifyMonoflopDone read monoflopDoneCallback write monoflopDoneCallback;
  end;

implementation

constructor TBrickletIO4.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'IO-4 Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 1;
  callbackWrappers[BRICKLET_IO4_CALLBACK_INTERRUPT] := {$ifdef FPC}@{$endif}CallbackWrapperInterrupt;
  callbackWrappers[BRICKLET_IO4_CALLBACK_MONOFLOP_DONE] := {$ifdef FPC}@{$endif}CallbackWrapperMonoflopDone;
end;

procedure TBrickletIO4.SetValue(const valueMask: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_SET_VALUE, 5);
  LEConvertUInt8To(valueMask, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO4.GetValue: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_GET_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO4_FUNCTION_GET_VALUE, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickletIO4.SetConfiguration(const pinMask: byte; const direction: char; const value: boolean);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_SET_CONFIGURATION, 7);
  LEConvertUInt8To(pinMask, 4, request);
  LEConvertCharTo(direction, 5, request);
  LEConvertBooleanTo(value, 6, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletIO4.GetConfiguration(out directionMask: byte; out valueMask: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_GET_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO4_FUNCTION_GET_CONFIGURATION, response);
  directionMask := LEConvertUInt8From(4, response);
  valueMask := LEConvertUInt8From(5, response);
end;

procedure TBrickletIO4.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO4.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO4_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletIO4.SetInterrupt(const interruptMask: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_SET_INTERRUPT, 5);
  LEConvertUInt8To(interruptMask, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIO4.GetInterrupt: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_GET_INTERRUPT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO4_FUNCTION_GET_INTERRUPT, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickletIO4.SetMonoflop(const pinMask: byte; const valueMask: byte; const time: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_SET_MONOFLOP, 10);
  LEConvertUInt8To(pinMask, 4, request);
  LEConvertUInt8To(valueMask, 5, request);
  LEConvertUInt32To(time, 6, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletIO4.GetMonoflop(const pin: byte; out value: byte; out time: longword; out timeRemaining: longword);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_IO4_FUNCTION_GET_MONOFLOP, 5);
  LEConvertUInt8To(pin, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_IO4_FUNCTION_GET_MONOFLOP, response);
  value := LEConvertUInt8From(4, response);
  time := LEConvertUInt32From(5, response);
  timeRemaining := LEConvertUInt32From(9, response);
end;

procedure TBrickletIO4.CallbackWrapperInterrupt(const packet: TByteArray);
var interruptMask: byte; valueMask: byte;
begin
  if (Assigned(interruptCallback)) then begin
    interruptMask := LEConvertUInt8From(4, packet);
    valueMask := LEConvertUInt8From(5, packet);
    interruptCallback(interruptMask, valueMask);
  end;
end;

procedure TBrickletIO4.CallbackWrapperMonoflopDone(const packet: TByteArray);
var pinMask: byte; valueMask: byte;
begin
  if (Assigned(monoflopDoneCallback)) then begin
    pinMask := LEConvertUInt8From(4, packet);
    valueMask := LEConvertUInt8From(5, packet);
    monoflopDoneCallback(pinMask, valueMask);
  end;
end;

end.
