{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletJoystick;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_JOYSTICK_FUNCTION_GET_POSITION = 1;
  BRICKLET_JOYSTICK_FUNCTION_IS_PRESSED = 2;
  BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE = 3;
  BRICKLET_JOYSTICK_FUNCTION_CALIBRATE = 4;
  BRICKLET_JOYSTICK_FUNCTION_SET_POSITION_CALLBACK_PERIOD = 5;
  BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_PERIOD = 6;
  BRICKLET_JOYSTICK_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
  BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
  BRICKLET_JOYSTICK_FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 9;
  BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 10;
  BRICKLET_JOYSTICK_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
  BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
  BRICKLET_JOYSTICK_FUNCTION_SET_DEBOUNCE_PERIOD = 13;
  BRICKLET_JOYSTICK_FUNCTION_GET_DEBOUNCE_PERIOD = 14;
  BRICKLET_JOYSTICK_CALLBACK_POSITION = 15;
  BRICKLET_JOYSTICK_CALLBACK_ANALOG_VALUE = 16;
  BRICKLET_JOYSTICK_CALLBACK_POSITION_REACHED = 17;
  BRICKLET_JOYSTICK_CALLBACK_ANALOG_VALUE_REACHED = 18;
  BRICKLET_JOYSTICK_CALLBACK_PRESSED = 19;
  BRICKLET_JOYSTICK_CALLBACK_RELEASED = 20;

type
  TBrickletJoystickNotifyPosition = procedure(const x: smallint; const y: smallint) of object;
  TBrickletJoystickNotifyAnalogValue = procedure(const x: word; const y: word) of object;
  TBrickletJoystickNotifyPositionReached = procedure(const x: smallint; const y: smallint) of object;
  TBrickletJoystickNotifyAnalogValueReached = procedure(const x: word; const y: word) of object;
  TBrickletJoystickNotifyPressed = procedure of object;
  TBrickletJoystickNotifyReleased = procedure of object;

  TBrickletJoystick = class(TDevice)
  private
    positionCallback: TBrickletJoystickNotifyPosition;
    analogValueCallback: TBrickletJoystickNotifyAnalogValue;
    positionReachedCallback: TBrickletJoystickNotifyPositionReached;
    analogValueReachedCallback: TBrickletJoystickNotifyAnalogValueReached;
    pressedCallback: TBrickletJoystickNotifyPressed;
    releasedCallback: TBrickletJoystickNotifyReleased;
  protected
    procedure CallbackWrapperPosition(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperPositionReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperPressed(const packet: TByteArray); virtual;
    procedure CallbackWrapperReleased(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure GetPosition(out x: smallint; out y: smallint); virtual;
    function IsPressed: boolean; virtual;
    procedure GetAnalogValue(out x: word; out y: word); virtual;
    procedure Calibrate; virtual;
    procedure SetPositionCallbackPeriod(const period: longword); virtual;
    function GetPositionCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetPositionCallbackThreshold(const option: char; const minX: smallint; const maxX: smallint; const minY: smallint; const maxY: smallint); virtual;
    procedure GetPositionCallbackThreshold(out option: char; out minX: smallint; out maxX: smallint; out minY: smallint; out maxY: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const minX: word; const maxX: word; const minY: word; const maxY: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out minX: word; out maxX: word; out minY: word; out maxY: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnPosition: TBrickletJoystickNotifyPosition read positionCallback write positionCallback;
    property OnAnalogValue: TBrickletJoystickNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnPositionReached: TBrickletJoystickNotifyPositionReached read positionReachedCallback write positionReachedCallback;
    property OnAnalogValueReached: TBrickletJoystickNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
    property OnPressed: TBrickletJoystickNotifyPressed read pressedCallback write pressedCallback;
    property OnReleased: TBrickletJoystickNotifyReleased read releasedCallback write releasedCallback;
  end;

implementation

constructor TBrickletJoystick.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Joystick Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_POSITION] := {$ifdef FPC}@{$endif}CallbackWrapperPosition;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_POSITION_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperPositionReached;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_PRESSED] := {$ifdef FPC}@{$endif}CallbackWrapperPressed;
  callbackWrappers[BRICKLET_JOYSTICK_CALLBACK_RELEASED] := {$ifdef FPC}@{$endif}CallbackWrapperReleased;
end;

procedure TBrickletJoystick.GetPosition(out x: smallint; out y: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION, response);
  x := LEConvertInt16From(4, response);
  y := LEConvertInt16From(6, response);
end;

function TBrickletJoystick.IsPressed: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_IS_PRESSED, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_IS_PRESSED, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickletJoystick.GetAnalogValue(out x: word; out y: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE, response);
  x := LEConvertUInt16From(4, response);
  y := LEConvertUInt16From(6, response);
end;

procedure TBrickletJoystick.Calibrate;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_CALIBRATE, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickletJoystick.SetPositionCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_SET_POSITION_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletJoystick.GetPositionCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletJoystick.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletJoystick.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletJoystick.SetPositionCallbackThreshold(const option: char; const minX: smallint; const maxX: smallint; const minY: smallint; const maxY: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, 13);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(minX, 5, request);
  LEConvertInt16To(maxX, 7, request);
  LEConvertInt16To(minY, 9, request);
  LEConvertInt16To(maxY, 11, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletJoystick.GetPositionCallbackThreshold(out option: char; out minX: smallint; out maxX: smallint; out minY: smallint; out maxY: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  minX := LEConvertInt16From(5, response);
  maxX := LEConvertInt16From(7, response);
  minY := LEConvertInt16From(9, response);
  maxY := LEConvertInt16From(11, response);
end;

procedure TBrickletJoystick.SetAnalogValueCallbackThreshold(const option: char; const minX: word; const maxX: word; const minY: word; const maxY: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 13);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(minX, 5, request);
  LEConvertUInt16To(maxX, 7, request);
  LEConvertUInt16To(minY, 9, request);
  LEConvertUInt16To(maxY, 11, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletJoystick.GetAnalogValueCallbackThreshold(out option: char; out minX: word; out maxX: word; out minY: word; out maxY: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  minX := LEConvertUInt16From(5, response);
  maxX := LEConvertUInt16From(7, response);
  minY := LEConvertUInt16From(9, response);
  maxY := LEConvertUInt16From(11, response);
end;

procedure TBrickletJoystick.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletJoystick.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_JOYSTICK_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_JOYSTICK_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletJoystick.CallbackWrapperPosition(const packet: TByteArray);
var x: smallint; y: smallint;
begin
  if (Assigned(positionCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    positionCallback(x, y);
  end;
end;

procedure TBrickletJoystick.CallbackWrapperAnalogValue(const packet: TByteArray);
var x: word; y: word;
begin
  if (Assigned(analogValueCallback)) then begin
    x := LEConvertUInt16From(4, packet);
    y := LEConvertUInt16From(6, packet);
    analogValueCallback(x, y);
  end;
end;

procedure TBrickletJoystick.CallbackWrapperPositionReached(const packet: TByteArray);
var x: smallint; y: smallint;
begin
  if (Assigned(positionReachedCallback)) then begin
    x := LEConvertInt16From(4, packet);
    y := LEConvertInt16From(6, packet);
    positionReachedCallback(x, y);
  end;
end;

procedure TBrickletJoystick.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var x: word; y: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    x := LEConvertUInt16From(4, packet);
    y := LEConvertUInt16From(6, packet);
    analogValueReachedCallback(x, y);
  end;
end;

procedure TBrickletJoystick.CallbackWrapperPressed(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(pressedCallback)) then begin
    pressedCallback();
  end;
end;

procedure TBrickletJoystick.CallbackWrapperReleased(const packet: TByteArray);
begin
  Assert(packet <> nil); { Avoid 'Parameter not used' warning }
  if (Assigned(releasedCallback)) then begin
    releasedCallback();
  end;
end;

end.
