{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletLCD16x2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_LCD_16X2_FUNCTION_WRITE_LINE = 1;
  BRICKLET_LCD_16X2_FUNCTION_CLEAR_DISPLAY = 2;
  BRICKLET_LCD_16X2_FUNCTION_BACKLIGHT_ON = 3;
  BRICKLET_LCD_16X2_FUNCTION_BACKLIGHT_OFF = 4;
  BRICKLET_LCD_16X2_FUNCTION_IS_BACKLIGHT_ON = 5;
  BRICKLET_LCD_16X2_FUNCTION_SET_CONFIG = 6;
  BRICKLET_LCD_16X2_FUNCTION_GET_CONFIG = 7;
  BRICKLET_LCD_16X2_FUNCTION_IS_BUTTON_PRESSED = 8;
  BRICKLET_LCD_16X2_CALLBACK_BUTTON_PRESSED = 9;
  BRICKLET_LCD_16X2_CALLBACK_BUTTON_RELEASED = 10;

type
  TBrickletLCD16x2NotifyButtonPressed = procedure(const button: byte) of object;
  TBrickletLCD16x2NotifyButtonReleased = procedure(const button: byte) of object;

  TBrickletLCD16x2 = class(TDevice)
  private
    buttonPressedCallback: TBrickletLCD16x2NotifyButtonPressed;
    buttonReleasedCallback: TBrickletLCD16x2NotifyButtonReleased;
  protected
    procedure CallbackWrapperButtonPressed(const packet: TByteArray); virtual;
    procedure CallbackWrapperButtonReleased(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    procedure WriteLine(const line: byte; const position: byte; const text: string); virtual;
    procedure ClearDisplay; virtual;
    procedure BacklightOn; virtual;
    procedure BacklightOff; virtual;
    function IsBacklightOn: boolean; virtual;
    procedure SetConfig(const cursor: boolean; const blinking: boolean); virtual;
    procedure GetConfig(out cursor: boolean; out blinking: boolean); virtual;
    function IsButtonPressed(const button: byte): boolean; virtual;
    property OnButtonPressed: TBrickletLCD16x2NotifyButtonPressed read buttonPressedCallback write buttonPressedCallback;
    property OnButtonReleased: TBrickletLCD16x2NotifyButtonReleased read buttonReleasedCallback write buttonReleasedCallback;
  end;

implementation

constructor TBrickletLCD16x2.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'LCD 16x2 Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_LCD_16X2_CALLBACK_BUTTON_PRESSED] := {$ifdef FPC}@{$endif}CallbackWrapperButtonPressed;
  callbackWrappers[BRICKLET_LCD_16X2_CALLBACK_BUTTON_RELEASED] := {$ifdef FPC}@{$endif}CallbackWrapperButtonReleased;
end;

procedure TBrickletLCD16x2.WriteLine(const line: byte; const position: byte; const text: string);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_WRITE_LINE, 22);
  LEConvertUInt8To(line, 4, request);
  LEConvertUInt8To(position, 5, request);
  LEConvertStringTo(text, 6, 16, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletLCD16x2.ClearDisplay;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_CLEAR_DISPLAY, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickletLCD16x2.BacklightOn;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_BACKLIGHT_ON, 4);
  SendRequestNoResponse(request);
end;

procedure TBrickletLCD16x2.BacklightOff;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_BACKLIGHT_OFF, 4);
  SendRequestNoResponse(request);
end;

function TBrickletLCD16x2.IsBacklightOn: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_IS_BACKLIGHT_ON, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_LCD_16X2_FUNCTION_IS_BACKLIGHT_ON, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickletLCD16x2.SetConfig(const cursor: boolean; const blinking: boolean);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_SET_CONFIG, 6);
  LEConvertBooleanTo(cursor, 4, request);
  LEConvertBooleanTo(blinking, 5, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletLCD16x2.GetConfig(out cursor: boolean; out blinking: boolean);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_GET_CONFIG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_LCD_16X2_FUNCTION_GET_CONFIG, response);
  cursor := LEConvertBooleanFrom(4, response);
  blinking := LEConvertBooleanFrom(5, response);
end;

function TBrickletLCD16x2.IsButtonPressed(const button: byte): boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_LCD_16X2_FUNCTION_IS_BUTTON_PRESSED, 5);
  LEConvertUInt8To(button, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_LCD_16X2_FUNCTION_IS_BUTTON_PRESSED, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickletLCD16x2.CallbackWrapperButtonPressed(const packet: TByteArray);
var button: byte;
begin
  if (Assigned(buttonPressedCallback)) then begin
    button := LEConvertUInt8From(4, packet);
    buttonPressedCallback(button);
  end;
end;

procedure TBrickletLCD16x2.CallbackWrapperButtonReleased(const packet: TByteArray);
var button: byte;
begin
  if (Assigned(buttonReleasedCallback)) then begin
    button := LEConvertUInt8From(4, packet);
    buttonReleasedCallback(button);
  end;
end;

end.
