{
  This file was automatically generated on 2012-09-17.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletRotaryPoti;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION = 1;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_ROTARY_POTI_FUNCTION_SET_POSITION_CALLBACK_PERIOD = 3;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_PERIOD = 4;
  BRICKLET_ROTARY_POTI_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
  BRICKLET_ROTARY_POTI_FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = 7;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = 8;
  BRICKLET_ROTARY_POTI_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
  BRICKLET_ROTARY_POTI_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_ROTARY_POTI_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_ROTARY_POTI_CALLBACK_POSITION = 13;
  BRICKLET_ROTARY_POTI_CALLBACK_ANALOG_VALUE = 14;
  BRICKLET_ROTARY_POTI_CALLBACK_POSITION_REACHED = 15;
  BRICKLET_ROTARY_POTI_CALLBACK_ANALOG_VALUE_REACHED = 16;

type
  TBrickletRotaryPotiNotifyPosition = procedure(const position: smallint) of object;
  TBrickletRotaryPotiNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletRotaryPotiNotifyPositionReached = procedure(const position: smallint) of object;
  TBrickletRotaryPotiNotifyAnalogValueReached = procedure(const value: word) of object;

  TBrickletRotaryPoti = class(TDevice)
  private
    positionCallback: TBrickletRotaryPotiNotifyPosition;
    analogValueCallback: TBrickletRotaryPotiNotifyAnalogValue;
    positionReachedCallback: TBrickletRotaryPotiNotifyPositionReached;
    analogValueReachedCallback: TBrickletRotaryPotiNotifyAnalogValueReached;
  protected
    procedure CallbackWrapperPosition(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperPositionReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    function GetPosition: smallint; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetPositionCallbackPeriod(const period: longword); virtual;
    function GetPositionCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetPositionCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetPositionCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnPosition: TBrickletRotaryPotiNotifyPosition read positionCallback write positionCallback;
    property OnAnalogValue: TBrickletRotaryPotiNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnPositionReached: TBrickletRotaryPotiNotifyPositionReached read positionReachedCallback write positionReachedCallback;
    property OnAnalogValueReached: TBrickletRotaryPotiNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletRotaryPoti.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Rotary Poti Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_ROTARY_POTI_CALLBACK_POSITION] := {$ifdef FPC}@{$endif}CallbackWrapperPosition;
  callbackWrappers[BRICKLET_ROTARY_POTI_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_ROTARY_POTI_CALLBACK_POSITION_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperPositionReached;
  callbackWrappers[BRICKLET_ROTARY_POTI_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletRotaryPoti.GetPosition: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION, response);
  result := LEConvertInt16From(4, response);
end;

function TBrickletRotaryPoti.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletRotaryPoti.SetPositionCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_SET_POSITION_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletRotaryPoti.GetPositionCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletRotaryPoti.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletRotaryPoti.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletRotaryPoti.SetPositionCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletRotaryPoti.GetPositionCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletRotaryPoti.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletRotaryPoti.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletRotaryPoti.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletRotaryPoti.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ROTARY_POTI_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ROTARY_POTI_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletRotaryPoti.CallbackWrapperPosition(const packet: TByteArray);
var position: smallint;
begin
  if (Assigned(positionCallback)) then begin
    position := LEConvertInt16From(4, packet);
    positionCallback(position);
  end;
end;

procedure TBrickletRotaryPoti.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletRotaryPoti.CallbackWrapperPositionReached(const packet: TByteArray);
var position: smallint;
begin
  if (Assigned(positionReachedCallback)) then begin
    position := LEConvertInt16From(4, packet);
    positionReachedCallback(position);
  end;
end;

procedure TBrickletRotaryPoti.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
